#!/usr/bin/python
# -*- coding: utf-8 -*-


CHARACTER_TIE = '&#x2040;'
CARET_INSERTION_POINT = '&#x2041;'
ASTERISM = '&#x2042;'
HYPHEN_BULLET = '&#x2043;'
FRACTION_SLASH = '&#x2044;'
LEFT_SQUARE_BRACKET_WITH_QUILL = '&#x2045;'
RIGHT_SQUARE_BRACKET_WITH_QUILL = '&#x2046;'
DOUBLE_QUESTION_MARK = '&#x2047;'
QUESTION_EXCLAMATION_MARK = '&#x2048;'
EXCLAMATION_QUESTION_MARK = '&#x2049;'
TIRONIAN_SIGN_ET = '&#x204A;'
REVERSED_PILCROW_SIGN = '&#x204B;'
BLACK_LEFTWARDS_BULLET = '&#x204C;'
BLACK_RIGHTWARDS_BULLET = '&#x204D;'
LOW_ASTERISK = '&#x204E;'
REVERSED_SEMICOLON = '&#x204F;'
CLOSE_UP = '&#x2050;'
TWO_ASTERISKS_ALIGNED_VERTICALLY = '&#x2051;'
COMMERCIAL_MINUS_SIGN = '&#x2052;'
SWUNG_DASH = '&#x2053;'
INVERTED_UNDERTIE = '&#x2054;'
FLOWER_PUNCTUATION_MARK = '&#x2055;'
THREE_DOT_PUNCTUATION = '&#x2056;'
QUADRUPLE_PRIME = '&#x2057;'
FOUR_DOT_PUNCTUATION = '&#x2058;'
FIVE_DOT_PUNCTUATION = '&#x2059;'
TWO_DOT_PUNCTUATION = '&#x205A;'
FOUR_DOT_MARK = '&#x205B;'
DOTTED_CROSS = '&#x205C;'
TRICOLON = '&#x205D;'
VERTICAL_FOUR_DOTS = '&#x205E;'
MEDIUM_MATHEMATICAL_SPACE = '&#x205F;'
WORD_JOINER = '&#x2060;'
FUNCTION_APPLICATION = '&#x2061;'
INVISIBLE_TIMES = '&#x2062;'
INVISIBLE_SEPARATOR = '&#x2063;'
INVISIBLE_PLUS = '&#x2064;'
LEFT_TO_RIGHT_ISOLATE = '&#x2066;'
RIGHT_TO_LEFT_ISOLATE = '&#x2067;'
FIRST_STRONG_ISOLATE = '&#x2068;'
POP_DIRECTIONAL_ISOLATE = '&#x2069;'
INHIBIT_SYMMETRIC_SWAPPING = '&#x206A;'
ACTIVATE_SYMMETRIC_SWAPPING = '&#x206B;'
INHIBIT_ARABIC_FORM_SHAPING = '&#x206C;'
ACTIVATE_ARABIC_FORM_SHAPING = '&#x206D;'
NATIONAL_DIGIT_SHAPES = '&#x206E;'
NOMINAL_DIGIT_SHAPES = '&#x206F;'
SUPERSCRIPT_ZERO = '&#x2070;'
SUPERSCRIPT_LATIN_SMALL_LETTER_I = '&#x2071;'
SUPERSCRIPT_FOUR = '&#x2074;'
SUPERSCRIPT_FIVE = '&#x2075;'
SUPERSCRIPT_SIX = '&#x2076;'
SUPERSCRIPT_SEVEN = '&#x2077;'
SUPERSCRIPT_EIGHT = '&#x2078;'
SUPERSCRIPT_NINE = '&#x2079;'
SUPERSCRIPT_PLUS_SIGN = '&#x207A;'
SUPERSCRIPT_MINUS = '&#x207B;'
SUPERSCRIPT_EQUALS_SIGN = '&#x207C;'
SUPERSCRIPT_LEFT_PARENTHESIS = '&#x207D;'
SUPERSCRIPT_RIGHT_PARENTHESIS = '&#x207E;'
SUPERSCRIPT_LATIN_SMALL_LETTER_N = '&#x207F;'
SUBSCRIPT_ZERO = '&#x2080;'
SUBSCRIPT_ONE = '&#x2081;'
SUBSCRIPT_TWO = '&#x2082;'
SUBSCRIPT_THREE = '&#x2083;'
SUBSCRIPT_FOUR = '&#x2084;'
SUBSCRIPT_FIVE = '&#x2085;'
SUBSCRIPT_SIX = '&#x2086;'
SUBSCRIPT_SEVEN = '&#x2087;'
SUBSCRIPT_EIGHT = '&#x2088;'
SUBSCRIPT_NINE = '&#x2089;'
SUBSCRIPT_PLUS_SIGN = '&#x208A;'
SUBSCRIPT_MINUS = '&#x208B;'
SUBSCRIPT_EQUALS_SIGN = '&#x208C;'
SUBSCRIPT_LEFT_PARENTHESIS = '&#x208D;'
SUBSCRIPT_RIGHT_PARENTHESIS = '&#x208E;'
LATIN_SUBSCRIPT_SMALL_LETTER_A = '&#x2090;'
LATIN_SUBSCRIPT_SMALL_LETTER_E = '&#x2091;'
LATIN_SUBSCRIPT_SMALL_LETTER_O = '&#x2092;'
LATIN_SUBSCRIPT_SMALL_LETTER_X = '&#x2093;'
LATIN_SUBSCRIPT_SMALL_LETTER_SCHWA = '&#x2094;'
LATIN_SUBSCRIPT_SMALL_LETTER_H = '&#x2095;'
LATIN_SUBSCRIPT_SMALL_LETTER_K = '&#x2096;'
LATIN_SUBSCRIPT_SMALL_LETTER_L = '&#x2097;'
LATIN_SUBSCRIPT_SMALL_LETTER_M = '&#x2098;'
LATIN_SUBSCRIPT_SMALL_LETTER_N = '&#x2099;'
LATIN_SUBSCRIPT_SMALL_LETTER_P = '&#x209A;'
LATIN_SUBSCRIPT_SMALL_LETTER_S = '&#x209B;'
LATIN_SUBSCRIPT_SMALL_LETTER_T = '&#x209C;'
EURO_CURRENCY_SIGN = '&#x20A0;'
COLON_SIGN = '&#x20A1;'
CRUZEIRO_SIGN = '&#x20A2;'
FRENCH_FRANC_SIGN = '&#x20A3;'
LIRA_SIGN = '&#x20A4;'
MILL_SIGN = '&#x20A5;'
NAIRA_SIGN = '&#x20A6;'
PESETA_SIGN = '&#x20A7;'
RUPEE_SIGN = '&#x20A8;'
WON_SIGN = '&#x20A9;'
NEW_SHEQEL_SIGN = '&#x20AA;'
DONG_SIGN = '&#x20AB;'
EURO_SIGN = '&#x20AC;'
KIP_SIGN = '&#x20AD;'
TUGRIK_SIGN = '&#x20AE;'
DRACHMA_SIGN = '&#x20AF;'
GERMAN_PENNY_SIGN = '&#x20B0;'
PESO_SIGN = '&#x20B1;'
GUARANI_SIGN = '&#x20B2;'
AUSTRAL_SIGN = '&#x20B3;'
HRYVNIA_SIGN = '&#x20B4;'
CEDI_SIGN = '&#x20B5;'
LIVRE_TOURNOIS_SIGN = '&#x20B6;'
SPESMILO_SIGN = '&#x20B7;'
TENGE_SIGN = '&#x20B8;'
INDIAN_RUPEE_SIGN = '&#x20B9;'
TURKISH_LIRA_SIGN = '&#x20BA;'
NORDIC_MARK_SIGN = '&#x20BB;'
MANAT_SIGN = '&#x20BC;'
RUBLE_SIGN = '&#x20BD;'
LARI_SIGN = '&#x20BE;'
BITCOIN_SIGN = '&#x20BF;'
COMBINING_LEFT_HARPOON_ABOVE = '&#x20D0;'
COMBINING_RIGHT_HARPOON_ABOVE = '&#x20D1;'
COMBINING_LONG_VERTICAL_LINE_OVERLAY = '&#x20D2;'
COMBINING_SHORT_VERTICAL_LINE_OVERLAY = '&#x20D3;'
COMBINING_ANTICLOCKWISE_ARROW_ABOVE = '&#x20D4;'
COMBINING_CLOCKWISE_ARROW_ABOVE = '&#x20D5;'
COMBINING_LEFT_ARROW_ABOVE = '&#x20D6;'
COMBINING_RIGHT_ARROW_ABOVE = '&#x20D7;'
COMBINING_RING_OVERLAY = '&#x20D8;'
COMBINING_CLOCKWISE_RING_OVERLAY = '&#x20D9;'
COMBINING_ANTICLOCKWISE_RING_OVERLAY = '&#x20DA;'
COMBINING_THREE_DOTS_ABOVE = '&#x20DB;'
COMBINING_FOUR_DOTS_ABOVE = '&#x20DC;'
COMBINING_ENCLOSING_CIRCLE = '&#x20DD;'
COMBINING_ENCLOSING_SQUARE = '&#x20DE;'
COMBINING_ENCLOSING_DIAMOND = '&#x20DF;'
COMBINING_ENCLOSING_CIRCLE_BACKSLASH = '&#x20E0;'
COMBINING_LEFT_RIGHT_ARROW_ABOVE = '&#x20E1;'
COMBINING_ENCLOSING_SCREEN = '&#x20E2;'
COMBINING_ENCLOSING_KEYCAP = '&#x20E3;'
COMBINING_ENCLOSING_UPWARD_POINTING_TRIANGLE = '&#x20E4;'
COMBINING_REVERSE_SOLIDUS_OVERLAY = '&#x20E5;'
COMBINING_DOUBLE_VERTICAL_STROKE_OVERLAY = '&#x20E6;'
COMBINING_ANNUITY_SYMBOL = '&#x20E7;'
COMBINING_TRIPLE_UNDERDOT = '&#x20E8;'
COMBINING_WIDE_BRIDGE_ABOVE = '&#x20E9;'
COMBINING_LEFTWARDS_ARROW_OVERLAY = '&#x20EA;'
COMBINING_LONG_DOUBLE_SOLIDUS_OVERLAY = '&#x20EB;'
COMBINING_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS = '&#x20EC;'
COMBINING_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS = '&#x20ED;'
COMBINING_LEFT_ARROW_BELOW = '&#x20EE;'
COMBINING_RIGHT_ARROW_BELOW = '&#x20EF;'
COMBINING_ASTERISK_ABOVE = '&#x20F0;'
ACCOUNT_OF = '&#x2100;'
ADDRESSED_TO_THE_SUBJECT = '&#x2101;'
DOUBLE_STRUCK_CAPITAL_C = '&#x2102;'
DEGREE_CELSIUS = '&#x2103;'
CENTRE_LINE_SYMBOL = '&#x2104;'
CARE_OF = '&#x2105;'
CADA_UNA = '&#x2106;'
EULER_CONSTANT = '&#x2107;'
SCRUPLE = '&#x2108;'
DEGREE_FAHRENHEIT = '&#x2109;'
SCRIPT_SMALL_G = '&#x210A;'
SCRIPT_CAPITAL_H = '&#x210B;'
BLACK_LETTER_CAPITAL_H = '&#x210C;'
DOUBLE_STRUCK_CAPITAL_H = '&#x210D;'
PLANCK_CONSTANT = '&#x210E;'
PLANCK_CONSTANT_OVER_TWO_PI = '&#x210F;'
SCRIPT_CAPITAL_I = '&#x2110;'
BLACK_LETTER_CAPITAL_I = '&#x2111;'
SCRIPT_CAPITAL_L = '&#x2112;'
SCRIPT_SMALL_L = '&#x2113;'
L_B_BAR_SYMBOL = '&#x2114;'
DOUBLE_STRUCK_CAPITAL_N = '&#x2115;'
NUMERO_SIGN = '&#x2116;'
SOUND_RECORDING_COPYRIGHT = '&#x2117;'
SCRIPT_CAPITAL_P = '&#x2118;'
DOUBLE_STRUCK_CAPITAL_P = '&#x2119;'
DOUBLE_STRUCK_CAPITAL_Q = '&#x211A;'
SCRIPT_CAPITAL_R = '&#x211B;'
BLACK_LETTER_CAPITAL_R = '&#x211C;'
DOUBLE_STRUCK_CAPITAL_R = '&#x211D;'
PRESCRIPTION_TAKE = '&#x211E;'
RESPONSE = '&#x211F;'
SERVICE_MARK = '&#x2120;'
TELEPHONE_SIGN = '&#x2121;'
TRADE_MARK_SIGN = '&#x2122;'
VERSICLE = '&#x2123;'
DOUBLE_STRUCK_CAPITAL_Z = '&#x2124;'
OUNCE_SIGN = '&#x2125;'
OHM_SIGN = '&#x2126;'
INVERTED_OHM_SIGN = '&#x2127;'
BLACK_LETTER_CAPITAL_Z = '&#x2128;'
TURNED_GREEK_SMALL_LETTER_IOTA = '&#x2129;'
KELVIN_SIGN = '&#x212A;'
ANGSTROM_SIGN = '&#x212B;'
SCRIPT_CAPITAL_B = '&#x212C;'
BLACK_LETTER_CAPITAL_C = '&#x212D;'
ESTIMATED_SYMBOL = '&#x212E;'
SCRIPT_SMALL_E = '&#x212F;'
SCRIPT_CAPITAL_E = '&#x2130;'
SCRIPT_CAPITAL_F = '&#x2131;'
TURNED_CAPITAL_F = '&#x2132;'
SCRIPT_CAPITAL_M = '&#x2133;'
SCRIPT_SMALL_O = '&#x2134;'
ALEF_SYMBOL = '&#x2135;'
BET_SYMBOL = '&#x2136;'
GIMEL_SYMBOL = '&#x2137;'
DALET_SYMBOL = '&#x2138;'
INFORMATION_SOURCE = '&#x2139;'
ROTATED_CAPITAL_Q = '&#x213A;'
FACSIMILE_SIGN = '&#x213B;'
DOUBLE_STRUCK_SMALL_PI = '&#x213C;'
DOUBLE_STRUCK_SMALL_GAMMA = '&#x213D;'
DOUBLE_STRUCK_CAPITAL_GAMMA = '&#x213E;'
DOUBLE_STRUCK_CAPITAL_PI = '&#x213F;'

NO_BREAK_SPACE = '&#xA0;'
INVERTED_EXCLAMATION_MARK = '&#xA1;'
CENT_SIGN = '&#xA2;'
POUND_SIGN = '&#xA3;'
CURRENCY_SIGN = '&#xA4;'
YEN_SIGN = '&#xA5;'
BROKEN_BAR = '&#xA6;'
SECTION_SIGN = '&#xA7;'
DIAERESIS = '&#xA8;'
COPYRIGHT_SIGN = '&#xA9;'
FEMININE_ORDINAL_INDICATOR = '&#xAA;'
LEFT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK = '&#xAB;'
NOT_SIGN = '&#xAC;'
SOFT_HYPHEN = '&#xAD;'
HYPHEN = '&#8211;'
REGISTERED_SIGN = '&#xAE;'
MACRON = '&#xAF;'
DEGREE_SIGN = '&#xB0;'
PLUS_MINUS_SIGN = '&#xB1;'
SUPERSCRIPT_TWO = '&#xB2;'
SUPERSCRIPT_THREE = '&#xB3;'
ACUTE_ACCENT = '&#xB4;'
MICRO_SIGN = '&#xB5;'
PILCROW_SIGN = '&#xB6;'
MIDDLE_DOT = '&#xB7;'
CEDILLA = '&#xB8;'
SUPERSCRIPT_ONE = '&#xB9;'
MASCULINE_ORDINAL_INDICATOR = '&#xBA;'
RIGHT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK = '&#xBB;'
VULGAR_FRACTION_ONE_QUARTER = '&#xBC;'
VULGAR_FRACTION_ONE_HALF = '&#xBD;'
VULGAR_FRACTION_THREE_QUARTERS = '&#xBE;'
INVERTED_QUESTION_MARK = '&#xBF;'
LATIN_CAPITAL_LETTER_A_WITH_GRAVE = '&#xC0;'
LATIN_CAPITAL_LETTER_A_WITH_ACUTE = '&#xC1;'
LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX = '&#xC2;'
LATIN_CAPITAL_LETTER_A_WITH_TILDE = '&#xC3;'
LATIN_CAPITAL_LETTER_A_WITH_DIAERESIS = '&#xC4;'
LATIN_CAPITAL_LETTER_A_WITH_RING_ABOVE = '&#xC5;'
LATIN_CAPITAL_LETTER_AE = '&#xC6;'
LATIN_CAPITAL_LETTER_C_WITH_CEDILLA = '&#xC7;'
LATIN_CAPITAL_LETTER_E_WITH_GRAVE = '&#xC8;'
LATIN_CAPITAL_LETTER_E_WITH_ACUTE = '&#xC9;'
LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX = '&#xCA;'
LATIN_CAPITAL_LETTER_E_WITH_DIAERESIS = '&#xCB;'
LATIN_CAPITAL_LETTER_I_WITH_GRAVE = '&#xCC;'
LATIN_CAPITAL_LETTER_I_WITH_ACUTE = '&#xCD;'
LATIN_CAPITAL_LETTER_I_WITH_CIRCUMFLEX = '&#xCE;'
LATIN_CAPITAL_LETTER_I_WITH_DIAERESIS = '&#xCF;'
LATIN_CAPITAL_LETTER_ETH = '&#xD0;'
LATIN_CAPITAL_LETTER_N_WITH_TILDE = '&#xD1;'
LATIN_CAPITAL_LETTER_O_WITH_GRAVE = '&#xD2;'
LATIN_CAPITAL_LETTER_O_WITH_ACUTE = '&#xD3;'
LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX = '&#xD4;'
LATIN_CAPITAL_LETTER_O_WITH_TILDE = '&#xD5;'
LATIN_CAPITAL_LETTER_O_WITH_DIAERESIS = '&#xD6;'
MULTIPLICATION_SIGN = '&#xD7;'
LATIN_CAPITAL_LETTER_O_WITH_STROKE = '&#xD8;'
LATIN_CAPITAL_LETTER_U_WITH_GRAVE = '&#xD9;'
LATIN_CAPITAL_LETTER_U_WITH_ACUTE = '&#xDA;'
LATIN_CAPITAL_LETTER_U_WITH_CIRCUMFLEX = '&#xDB;'
LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS = '&#xDC;'
LATIN_CAPITAL_LETTER_Y_WITH_ACUTE = '&#xDD;'
LATIN_CAPITAL_LETTER_THORN = '&#xDE;'
LATIN_SMALL_LETTER_SHARP_S = '&#xDF;'
LATIN_SMALL_LETTER_A_WITH_GRAVE = '&#xE0;'
LATIN_SMALL_LETTER_A_WITH_ACUTE = '&#xE1;'
LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX = '&#xE2;'
LATIN_SMALL_LETTER_A_WITH_TILDE = '&#xE3;'
LATIN_SMALL_LETTER_A_WITH_DIAERESIS = '&#xE4;'
LATIN_SMALL_LETTER_A_WITH_RING_ABOVE = '&#xE5;'
LATIN_SMALL_LETTER_AE = '&#xE6;'
LATIN_SMALL_LETTER_C_WITH_CEDILLA = '&#xE7;'
LATIN_SMALL_LETTER_E_WITH_GRAVE = '&#xE8;'
LATIN_SMALL_LETTER_E_WITH_ACUTE = '&#xE9;'
LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX = '&#xEA;'
LATIN_SMALL_LETTER_E_WITH_DIAERESIS = '&#xEB;'
LATIN_SMALL_LETTER_I_WITH_GRAVE = '&#xEC;'
LATIN_SMALL_LETTER_I_WITH_ACUTE = '&#xED;'
LATIN_SMALL_LETTER_I_WITH_CIRCUMFLEX = '&#xEE;'
LATIN_SMALL_LETTER_I_WITH_DIAERESIS = '&#xEF;'
LATIN_SMALL_LETTER_ETH = '&#xF0;'
LATIN_SMALL_LETTER_N_WITH_TILDE = '&#xF1;'
LATIN_SMALL_LETTER_O_WITH_GRAVE = '&#xF2;'
LATIN_SMALL_LETTER_O_WITH_ACUTE = '&#xF3;'
LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX = '&#xF4;'
LATIN_SMALL_LETTER_O_WITH_TILDE = '&#xF5;'
LATIN_SMALL_LETTER_O_WITH_DIAERESIS = '&#xF6;'
DIVISION_SIGN = '&#xF7;'
LATIN_SMALL_LETTER_O_WITH_STROKE = '&#xF8;'
LATIN_SMALL_LETTER_U_WITH_GRAVE = '&#xF9;'
LATIN_SMALL_LETTER_U_WITH_ACUTE = '&#xFA;'
LATIN_SMALL_LETTER_U_WITH_CIRCUMFLEX = '&#xFB;'
LATIN_SMALL_LETTER_U_WITH_DIAERESIS = '&#xFC;'
LATIN_SMALL_LETTER_Y_WITH_ACUTE = '&#xFD;'
LATIN_SMALL_LETTER_THORN = '&#xFE;'
LATIN_SMALL_LETTER_Y_WITH_DIAERESIS = '&#xFF;'
EM_DASH = '&#x2014;'

# https://dwheeler.com/essays/quotes-in-html.html
LEFT_DOUBLE_QUOTE_MARK = '&#8220;'

# https://dwheeler.com/essays/quotes-in-html.html
RIGHT_DOUBLE_QUOTE_MARK = '&#8221;'
